Beers.Overflow/Beers.Web/Controllers/BeerReviewsController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using Beers.Data.Context;
using Beers.Models;
using Beers.Services.Contracts;
using Beers.Web.Models;
using Beers.Services.DTOs;
using Beers.Services;
using System.ComponentModel.Design;
using Microsoft.AspNetCore.SignalR;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Authorization;

namespace Beers.Web.Controllers
{
    [Authorize]
    public class BeerReviewsController : Controller
    {
        private readonly IBeerReviewService _service;
        private readonly IBeerService _beerService;
        private readonly IUserService _userService;

        public BeerReviewsController(IBeerReviewService service, IBeerService beerService, IUserService userService)
        {
            _service = service;
            _beerService = beerService;
            _userService = userService;
        }

        // GET: BeerReviews
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Index()
        {
            var allBeerReviewsDTO = await _service.GetAllReviews();

            var allBeerReviwesView = allBeerReviewsDTO.Select(x => new BeerReviewViewModel(x));

            return View(allBeerReviwesView);
        }

        // GET: BeerReviews/Details/5
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Details(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var beerReview = await _service.GetById((int)id);

            if (beerReview == null)
            {
                return NotFound();
            }

            return View(beerReview);
        }

        //GET: BeerReviews/Create

        public async Task<IActionResult> CreateAsync(int? id)
        {
            var newReview = new BeerReviewViewModel()
            {
                BeerId = (int)id,
                UserId = await _userService.GetUserIdAsync(HttpContext)
            };

            return View(newReview);
        }

        // POST: BeerReviews/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> CreateReview(BeerReviewDTO beerReview)
        {
            if (ModelState.IsValid)
            {
                var userId = await _userService.GetUserIdAsync(HttpContext);

                if ((await this._service.CheckIfReviewed(beerReview.BeerId, userId)) == true)
                {
                    return RedirectToAction("Details", "Beers", new { id = beerReview.BeerId, error = TempData["Error"] = "You cant review twice BOI!"});
                }

                await _service.Create(beerReview);
                return RedirectToAction("Details", "Beers", new { id = beerReview.BeerId});
            }

            return View(beerReview);
        }

        // GET: BeerReviews/Edit/5
        public async Task<IActionResult> Edit(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var beerReview = await _service.GetById((int)id);

            if (beerReview == null)
            {
                return NotFound();
            }

            return View(beerReview);
        }

        // POST: BeerReviews/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(int id, [Bind("Content,BeerId,UserId")] BeerReviewDTO beerReviewDTO)
        {
            if (id != beerReviewDTO.BeerId)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                try
                {
                    await _service.Update(id, beerReviewDTO);
                }
                catch (DbUpdateConcurrencyException)
                {
                    if (!BeerReviewExists(beerReviewDTO.BeerId))
                    {
                        return NotFound();
                    }
                    else
                    {
                        throw;
                    }
                }
                return RedirectToAction(nameof(Index));
            }

            var beerReviewViewModel = new BeerReviewViewModel(beerReviewDTO);

            return View(beerReviewViewModel);
        }

        // GET: BeerReviews/Delete/5
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Delete(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var beerReview = await _service.GetById((int)id);

            if (beerReview == null)
            {
                return NotFound();
            }

            return View(beerReview);
        }

        // POST: BeerReviews/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            await _service.Delete(id);

            return RedirectToAction(nameof(Index));
        }

        private bool BeerReviewExists(int id)
        {
            if (_service.GetById(id) == null)
            {
                return false;
            }
            return true;
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize]
        public async Task<IActionResult> LikeReview(int reviewId, int beerId)
        {
            var userId = await this._userService.GetUserIdAsync(HttpContext);

            if (await this._service.Like(reviewId, userId) == true)
            {
                return RedirectToAction("Details", "Beers", new { id = beerId, msg = TempData["Msg"] = "Review Liked !" });
            }

            return RedirectToAction("Details", "Beers", new { id = beerId, msg = TempData["Msg"] = "You have already liked that review!" });
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize]
        public async Task<IActionResult> DislikeReview(int reviewId, int beerId)
        {
            var userId = await this._userService.GetUserIdAsync(HttpContext);

            if (await this._service.Dislike(reviewId, userId) == true)
            {
                return RedirectToAction("Details", "Beers", new { id = beerId, msg = TempData["Msg"] = "Review Disliked !" });
            }

            return RedirectToAction("Details", "Beers", new { id = beerId, msg = TempData["Msg"] = "You have already Disliked that review!" });
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize]
        public async Task<IActionResult> ReportReview(int reviewId, int beerId)
        {

            if (await this._service.Report(reviewId) == true)
            {
                return RedirectToAction("Details", "Beers", new { id = beerId, msg = TempData["Msg"] = "Review Reported !" });
            }

            return RedirectToAction("Details", "Beers", new { id = beerId, error = TempData["Error"] = "This review is already reported!" });
        }
    }
}

Beers.Overflow/Beers.Web/Controllers/BeersController.cs
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using Beers.Services.Contracts;
using Beers.Web.Models;
using Beers.Services.DTOs;
using Microsoft.AspNetCore.Authorization;

namespace Beers.Web.Controllers
{
    public class BeersController : Controller
    {
        private readonly IBeerService _service;
        private readonly IBreweryService _breweryService;
        private readonly IStyleService _styleService;
        private readonly IUserService _userService;
        private readonly IBeerReviewService _beerReviewService;

        public BeersController(IBeerService service,
                               IBreweryService breweryService,
                               IStyleService styleService,
                               IUserService userService,
                               IBeerReviewService beerReviewService)
        {
            this._service = service;
            this._breweryService = breweryService;
            this._styleService = styleService;
            this._userService = userService;
            this._beerReviewService = beerReviewService;
        }

        // GET: Beers
        public async Task<IActionResult> Index(string styleId, string breweryId, bool orderByABV, string query)
        {
            var beers = new BeerIndexViewModel(_service, _styleService, _breweryService);
            var resultedBeers = await beers.GetBeers();
            beers.Query = query;

            if (styleId == "No Select" || styleId == null)
            {
                beers.BeersList = resultedBeers.ToList();
            }
            else
            {
                beers.StyleIdToFilter = styleId;
                beers.BeersList = resultedBeers.Where(x => x.StyleId == int.Parse(styleId)).ToList();
            }


            if (breweryId != null && breweryId != "No Select")
            {
                beers.BreweryIdToFilter = breweryId;
                beers.BeersList = beers.BeersList.Where(x => x.BreweryId == int.Parse(breweryId)).ToList();
            }

            if (orderByABV == true)
            {
                beers.BeersList = beers.BeersList.OrderBy(x => x.ABV).ToList();
            }

            if (query != "" && query != null)
            {
                beers.BeersList = beers.BeersList.Where(x => x.Name.Contains(query)).ToList();
            }

            return View(beers);
        }

        [HttpPost]
        public IActionResult FilterStyle(BeerIndexViewModel beerIndexData)
        {

            return RedirectToAction("Index", "Beers",
                new
                {
                    styleId = beerIndexData.StyleIdToFilter,
                    breweryId = beerIndexData.BreweryIdToFilter,
                    orderByABV = beerIndexData.OrderByABV,
                    query = beerIndexData.Query,
                });
        }

        // GET: Beers/Details/5
        public async Task<IActionResult> Details(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var beerDTO = await _service.GetBeer((int)id);

            if (beerDTO == null)
            {
                return NotFound();
            }

            if (HttpContext.User.Identity.IsAuthenticated)
            {
                var userId = await _userService.GetUserIdAsync(HttpContext);
                ViewBag.UserId = userId;
                ViewBag.UserName = HttpContext.User.Identity.Name;
            }

            var country = await _breweryService.GetBrewery(beerDTO.BreweryId);
            var style = await _styleService.GetStyle(beerDTO.StyleId);
           
            var rating = await this._service.GetBeerRating((int)id);

            ViewBag.BeerCountry = country.Name;
            ViewBag.BeerStyle = style.StyleType;
            ViewBag.Rating = string.Format("{0:0.00}", rating);
            ViewBag.Reviews = await this._beerReviewService.GetReviewsByBeer((int)id);


            var beerView = new BeerViewModel(beerDTO);

            return View(beerView);
        }

        // GET: Beers/Create
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Create()
        {


            ViewData["StyleId"] = new SelectList(await _styleService.GetAllStyles(), "Id", "StyleType");
            //ViewData["CreatedByUserId"] = new SelectList(_context.Users, "Id", "Name", beer.CreatedByUserId);
            ViewData["BreweryId"] = new SelectList(await _breweryService.GetAllBreweries(), "Id", "Name");

            return View();
        }

        // POST: Beers/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Create([Bind("Id,Name,Description,Brand,ABV,StyleId,BreweryId")] BeerDTO beerDTO)
        {
            if (ModelState.IsValid)
            {
                await _service.Create(beerDTO);

                return RedirectToAction(nameof(Index));
            }

            ViewData["Styles"] = new SelectList(await _styleService.GetAllStyles(), "Id", "StyleType");
            ViewData["Breweries"] = new SelectList(await _breweryService.GetAllBreweries(), "Id", "Name");

            var beerView = new BeerViewModel(beerDTO);

            return View(beerView);
        }

        // GET: Beers/Edit/5
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Edit(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var beerDTO = await _service.GetBeer((int)id);

            if (beerDTO == null)
            {
                return NotFound();
            }
            ViewData["BreweryId"] = new SelectList(await _breweryService.GetAllBreweries(), "Id", "Name", beerDTO.BreweryId);
            //ViewData["CreatedByUserId"] = new SelectList(_context.Users, "Id", "Name", beer.CreatedByUserId);
            ViewData["StyleId"] = new SelectList(await _styleService.GetAllStyles(), "Id", "StyleType", beerDTO.StyleId);

            var beerView = new BeerViewModel(beerDTO);

            return View(beerView);
        }

        // POST: Beers/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Edit(int id, BeerDTO beerDTO)
        {
            if (id != beerDTO.Id)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                try
                {
                    await _service.Update(id, beerDTO);
                }
                catch (DbUpdateConcurrencyException)
                {
                    if (!BeerExists(beerDTO.Id))
                    {
                        return NotFound();
                    }
                    else
                    {
                        throw;
                    }
                }
                return RedirectToAction(nameof(Index));
            }
            ViewData["BreweryId"] = new SelectList(await _breweryService.GetAllBreweries(), "Id", "Name", beerDTO.BreweryId);
            //ViewData["CreatedByUserId"] = new SelectList(_context.Users, "Id", "Name", beer.CreatedByUserId);
            ViewData["StyleId"] = new SelectList(await _styleService.GetAllStyles(), "Id", "StyleType", beerDTO.StyleId);

            var beerView = new BeerViewModel(beerDTO);

            return View(beerView);
        }

        // GET: Beers/Delete/5
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Delete(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var beerDTO = await _service.GetBeer((int)id);

            if (beerDTO == null)
            {
                return NotFound();
            }

            var beerView = new BeerViewModel(beerDTO);

            return View(beerView);
        }

        // POST: Beers/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            var beer = await _service.Delete(id);

            return RedirectToAction(nameof(Index));
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize]
        public async Task<IActionResult> RateBeer(int beerId, int rating)
        {
            var userId = await this._userService.GetUserIdAsync(HttpContext);

            await _service.RateBeer(beerId, rating, userId);

            return RedirectToAction("Details", "Beers", new { id = beerId, msg = TempData["Msg"] = $"Your gave this one a {rating} !" });
        }

        private bool BeerExists(int id)
        {
            var beer = _service.GetBeer(id);

            if (beer != null)
            {
                return true;
            }
            return false;
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize]
        public async Task<IActionResult> AddToWish(int? beerId)
        {
            if (beerId == null)
            {
                return NotFound();
            }

            var userId = await this._userService.GetUserIdAsync(HttpContext);

            var userBeer = new UserBeerRelationsDTO()
            {
                UserId = userId,
                BeerId = (int)beerId,
                Wish = true
            };

            var added = await this._userService.AddToWishList(userBeer);

            if (added == true)
            {
                return RedirectToAction("Details", "Beers", new { id = userBeer.BeerId, msg = TempData["Msg"] = "Beer added to Wishlist." });
            }
            else
            {

Beers.Overflow/Beers.Web/Views/Beers/Addtodrank.cshtml
@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
}

Beers.Overflow/Beers.Web/Views/Beers/Addtowish.cshtml
@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
}

Beers.Overflow/Beers.Web/Views/Beers/Create.cshtml
@model BeerViewModel

@{
    Layout = "_Layout";
    ViewData["Breweries"] = "breweries";
    ViewData["Styles"] = "styles";
}
<body>

<h4>Beer</h4> 
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Create">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="Name" class="control-label"></label>
                <input asp-for="Name" class="form-control" />
                <span asp-validation-for="Name" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Description" class="control-label"></label>
                <input asp-for="Description" class="form-control" />
                <span asp-validation-for="Description" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Brand" class="control-label"></label>
                <input asp-for="Brand" class="form-control" />
                <span asp-validation-for="Brand" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="ABV" class="control-label"></label>
                <input asp-for="ABV" class="form-control" />
                <span asp-validation-for="ABV" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="StyleId" class="control-label">Style</label>
                <select asp-for="StyleId" class ="form-control" asp-items="@ViewBag.StyleId"></select>
            </div>
            <div class="form-group">
                <label asp-for="BreweryId" class="control-label">Brewery</label>
                <select asp-for="BreweryId" class ="form-control" asp-items="@ViewBag.BreweryId"></select>
            </div>
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}
</body>

Beers.Overflow/Beers.Web/Views/Beers/Delete.cshtml
@model BeerViewModel

@{
    Layout = "_Layout";
}

<!DOCTYPE html>

<html>
<head>
    <meta name="viewport" content="width=device-width" />
    <title>Delete</title>
</head>
<body>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>Beer</h4>
    <hr />
    <dl class="row">
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Name)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Name)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Description)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Description)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Brand)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Brand)
        </dd>
        @*<dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Brewery)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Brewery.Name)
        </dd class>*@
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.ABV)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.ABV)
        </dd>
    </dl>
    
    <form asp-action="Delete">
        <input type="hidden" asp-for="Id" />
        <input type="submit" value="Delete" class="btn btn-danger" /> |
        <a asp-action="Index">Back to List</a>
    </form>
</div>
</body>
</html>

Beers.Overflow/Beers.Web/Views/Beers/Details.cshtml
@model BeerViewModel

@{
    Layout = "_Layout";
}
<body>

    <!-- Page Content -->
    <div class="container">

        <!-- Portfolio Item Heading -->
        <h1 class="my-4">
            @Model.Name
        </h1>

        <!-- Portfolio Item Row -->
        <div class="row">

            <div class="col-md-8">
                <img class="img-fluid" src="~/img/SingleBeer1.jpg" alt="">
            </div>

            <div class="col-md-4">
                <h3 class="my-3">Description</h3>
                <p>@Model.Description</p>
                <h3 class="my-3">Details</h3>
                <ul>
                    <li>@Model.Brand</li>
                    <li>@Model.ABV</li>
                    <li>@ViewBag.BeerStyle</li>
                    <li>@ViewBag.BeerCountry</li>
                </ul>
                <!-- rating stars -->
                <div class="rating-block">
                    <h4>Average user rating</h4>
                    <h2 class="bold padding-bottom-7">@ViewBag.Rating <small>/ 5</small></h2>

                    @if (User.Identity.IsAuthenticated)
                    {
                        <form class="form-horizontal" method="post" asp-controller="Beers" asp-action="RateBeer">
                            <input type="hidden" name="beerId" value="@Model.Id" />
                            <label for="inputState">Rate it</label>
                            <select id="inputState" class="form-control" name="rating">
                                <option selected value="0" name="rating">0</option>
                                <option value="1" name="rating">1</option>
                                <option value="2" name="rating">2</option>
                                <option value="3" name="rating">3</option>
                                <option value="4" name="rating">4</option>
                                <option value="5" name="rating">5</option>
                            </select>
                            <input class="btn btn-light" type="submit" value="Rate this beer" />
                        </form>
                    }

                    <button type="button" class="btn btn-warning btn-sm" aria-label="Left Align">
                        <span class="glyphicon glyphicon-star" aria-hidden="true"></span>
                    </button>
                    <button type="button" class="btn btn-warning btn-sm" aria-label="Left Align">
                        <span class="glyphicon glyphicon-star" aria-hidden="true"></span>
                    </button>
                    <button type="button" class="btn btn-warning btn-sm" aria-label="Left Align">
                        <span class="glyphicon glyphicon-star" aria-hidden="true"></span>
                    </button>
                    <button type="button" class="btn btn-default btn-grey btn-sm" aria-label="Left Align">
                        <span class="glyphicon glyphicon-star" aria-hidden="true"></span>
                    </button>
                    <button type="button" class="btn btn-default btn-grey btn-sm" aria-label="Left Align">
                        <span class="glyphicon glyphicon-star" aria-hidden="true"></span>
                    </button>
                </div>
                <!-- rating stars end -->
            </div>
            <!-- rating card -->
            <!-- rating card  end -->
            <div>
                @if (User.Identity.IsAuthenticated)
                {
                    if (User.IsInRole("Admin"))
                    {
                        <a class="btn btn-light" asp-action="Edit" asp-route-id="@Model.Id">Edit</a>
                    }
                }
                <a class="btn btn-light" asp-action="Index">Back to List</a>
            </div>
        </div>
        <!-- /.row -->
        @if (User.Identity.IsAuthenticated)
        {
            @if (TempData["Msg"] != null)
            {
                <div class="alert alert-danger" role="alert">
                    @TempData["Msg"].ToString();
                </div>
            }
            <form class="form-horizontal" method="post" asp-controller="Beers" asp-action="AddToWish">
                <input type="hidden" name="beerId" value="@Model.Id" />
                <input class="btn btn-light" type="submit" value="Add to Wishlist" />
            </form>
            <form class="form-horizontal" method="post" asp-controller="Beers" asp-action="AddToDrank">
                <input type="hidden" name="beerId" value="@Model.Id" />
                <input class="btn btn-light" type="submit" value="Add to Dranklist" />
            </form>
        }
        @if (User.Identity.IsAuthenticated)
        {
            <!-- post Review-->
            <form class="form-horizontal" method="post" asp-controller="BeerReviews" asp-action="CreateReview">
                <fieldset>
                    <!-- Form Name -->
                    <legend>Tell us what you think about it</legend>

                    @if (TempData["Error"] != null)
                    {
                        <div class="alert alert-danger" role="alert">
                            You cant review a second time BOIIII!!!!
                        </div>
                    }
                    <!-- Textarea -->
                    <div class="form-group">
                        <label class="col-md-4 control-label" for="textarea">Review</label>
                        <div class="col-md-4">
                            <textarea name="Content" class="form-control" id="textarea" placeholder="put some text here"></textarea>
                        </div>
                    </div>

                    <!-- Button -->
                    <div class="form-group">
                        <label class="col-md-4 control-label" for="singlebutton">Single Button</label>
                        <div class="col-md-4">
                            <input type="hidden" name="BeerId" value="@Model.Id" />
                            <input type="hidden" name="UserId" value="@ViewBag.UserId" />
                            <input type="hidden" name="UserName" value="@ViewBag.UserName" />
                            <button class="btn btn-primary" type="submit">Post</button>
                        </div>
                    </div>

                </fieldset>
            </form>
            <!--post review end-->
        }


        <!-- reviews start -->
        <div class="container">
            <h3 class="text-center">Reviews</h3>
            @foreach (var item in ViewBag.Reviews)
            {
                <div class="card">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-2">
                                <img src="https://image.ibb.co/jw55Ex/def_face.jpg" class="img img-rounded img-fluid" />
                                <p class="text-secondary text-center">@item.CreatedOn</p>
                            </div>
                            <div class="col-md-10">
                                <p>
                                    <a class="float-left" href="https://maniruzzaman-akash.blogspot.com/p/contact.html"><strong>@item.UserName</strong></a>
                                </p>
                                <div class="clearfix"></div>
                                <p>@item.Content</p>
                                @if (User.Identity.IsAuthenticated)//TODO:
                                {
                                    <div class="d-flex flex-row-reverse bd-highlight">
                                        <form class="form-horizontal" method="post" asp-controller="BeerReviews" asp-action="LikeReview">
                                            <input type="hidden" name="beerId" value="@Model.Id" />
                                            <input type="hidden" name="reviewId" value="@item.Id" />
                                            <input class="btn btn-labeled btn-success" type="submit" value="@item.Likes Like" />
                                        </form>
                                        <form class="form-horizontal" method="post" asp-controller="BeerReviews" asp-action="DislikeReview">
                                            <input type="hidden" name="beerId" value="@Model.Id" />
                                            <input type="hidden" name="reviewId" value="@item.Id" />
                                            <input class="btn btn-labeled btn-warning" type="submit" value="@item.Dislikes Dislike" />
                                        </form>
                                        <form class="form-horizontal" method="post" asp-controller="BeerReviews" asp-action="ReportReview">
                                            <input type="hidden" name="beerId" value="@Model.Id" />
                                            <input type="hidden" name="reviewId" value="@item.Id" />
                                            <input class="btn btn-labeled btn-danger" type="submit" value="Report" />
                                        </form>
                                    </div>
                                }
                            </div>
                        </div>
                    </div>
                </div>
            }
            <!-- reviews end -->
            <!-- /.row -->

        </div>
        <!-- /.container -->
    </div>
</body>